# Tokenomics + Network Report

This is a report which explains the current state of the Joystream network in numbers. It pulls figures from the chain and tries to provide a basic level of information about the network, tokens and more. 

## 1.0 Basic Information

* Block range: 4395600 - 4496399
* Date Range: 02/09/2022 18:50:18 - 02/16/2022 19:31:36
* Council session #: 43
* Term Duration [s]: 607278
* Ideal Term Duration [s]: 604794
* Difference: 2484s (41 minutes)
* Average Block Time: 6.025s

## 2.0 Tokenomics

### 2.1 Token generation breakdown

| Property            | Start Block | End Block | % Change |
|---------------------|--------------|--------------|----------|
| Total Tokens Minted |  2864449816 | 2883530444 | 0.67 |
| USD Pool |  67676.59 | 66860.00 | -1.21 |

| Role                | Value        |
|---------------------|--------------|
| Total Tokens Burned | 196736784 |
| Spending Proposals (Executed) | 33702095 |
| Bounties paid       | 27180356 |
| Validator Role      | 7921288 |
| Council | 38562095 |
| Curators | 12410326 |
| Storage Providers | 6302080 |
| Distribution | 25741671 |
| Operations | 29418068 |
| Marketing | 2503926 |
| Gamma | 0 |


### 2.2 Fiat Pool

| Property            | Start Block, USD | End Block, USD | % Change |
|---------------------|--------------|--------------|----------|
| USD Pool |  67676.59 | 66860.00 | -1.21 |

| Refill, USD | Reason | Block # |
|---------------------|--------------|--------------|
| 2002 | kpi-sumer-40 | 4468467 |
| 1641 | recurring-sumer-40 | 4468469 |


### 2.3 Mints

| Minted per Role             | Start Block           | End Block | Difference | % Change |
|-----------------------------|-----------------------|-----------|------------|----------|
| Council Total Minted | 1388892415.00 | 1427454510.00 | 38562095 | 2.78 |
| Curators Minted | 287968245.00 | 300378571.00 | 12410326 | 4.31 |
| Storage Providers Minted | 271151621.00 | 277453701.00 | 6302080 | 2.32 |
| Distribution Minted | 21042059.00 | 46783730.00 | 25741671 | 122.33 |
| Operations Minted | 385315415.00 | 414733483.00 | 29418068 | 7.63 |
| Marketing Minted | 0.00 | 2503926.00 | 2503926 | Infinity |
| Gamma Minted | 0.00 | 0.00 | 0 | 0 |


### 2.4 tJOY Inflation

* Start Block Exchange Rate, USD/1M tJOY: 23.65
* End Block Exchange Rate, USD/1M tJOY: 23.41
* Inflation, %: 1.04

Negative value indicates deflation

## 3.0 Council

* Council session #: 43
* Number of council members: 20
* Total number of proposals: 29
* Total number of Approved proposals: 28

### 3.1 Elections

| Property                    | Start Block  |
|-----------------------------|--------------|
| Total Applicants            | 29 |
| Total Applicant Stake       | 503404401 |
| Total Votes                 | 38 |

## 4 Roles

### 4.1 Validator Information

* Block generation time (average): 6.02

| Property                   | Start Block | End Block | % Change |
|----------------------------|--------------|--------------|----------|
| Number of Validators       | 56 / 75 | 53 / 75 | -5.36 |
| Validator Total Stake      | 543282149 | 468747463 | -13.72 |

### 4.2 Curators
* [openings for contentWorkingGroup](https://testnet.joystream.org/#/working-groups/opportunities/curators)

| Property                | Start Block | End Block | % Change |
|-------------------------|--------------|--------------|----------|
| Number of  Workers | 9 | 8 | -11.11 |
| Total  Stake | 500000 | 500000 | 0 |

| # | Member | Status | tJOY / Block | M tJOY Term | M tJOY total |
|--|--|--|--|--|--|
| 7 | [@l1dev](https://pioneer.joystreamstats.live/#/members/l1dev) | active | 0 | 0.0 | 11.7 |
| 16 | [@kira_skipper](https://pioneer.joystreamstats.live/#/members/kira_skipper) | active | 23 | 1.5 | 31.5 |
| 18 | [@mmsaww](https://pioneer.joystreamstats.live/#/members/mmsaww) | active | 12 | 1.2 | 29.0 |
| 22 | [@igrex](https://pioneer.joystreamstats.live/#/members/igrex) | active | 12 | 1.2 | 24.6 |
| 23 | [@oxygen](https://pioneer.joystreamstats.live/#/members/oxygen) | active | 65 | 4.3 | 19.2 |
| 24 | [@spat_sochi](https://pioneer.joystreamstats.live/#/members/spat_sochi) | active | 12 | 1.2 | 8.2 |
| 27 | [@arseniy2706](https://pioneer.joystreamstats.live/#/members/arseniy2706) | active | 12 | 1.2 | 6.2 |
| 28 | [@jen4ph](https://pioneer.joystreamstats.live/#/members/jen4ph) | active | 12 | 1.2 | 6.2 |


### 4.3 Storage Providers
* [openings for storageWorkingGroup](https://testnet.joystream.org/#/working-groups/opportunities/storageProviders)

| Property                | Start Block | End Block | % Change |
|-------------------------|--------------|--------------|----------|
| Number of  Workers | 11 | 11 | 0 |
| Total  Stake | 1100000 | 1100000 | 0 |

| # | Member | Status | tJOY / Block | M tJOY Term | M tJOY total |
|--|--|--|--|--|--|
| 3 | [@joystreamstats](https://pioneer.joystreamstats.live/#/members/joystreamstats) | active | 13 | 0.7 | 27.3 |
| 4 | [@julysake](https://pioneer.joystreamstats.live/#/members/julysake) | active | 3 | 0.5 | 27.0 |
| 6 | [@kalpakci](https://pioneer.joystreamstats.live/#/members/kalpakci) | active | 3 | 0.5 | 27.2 |
| 15 | [@maxlevush](https://pioneer.joystreamstats.live/#/members/maxlevush) | active | 13 | 0.7 | 22.3 |
| 16 | [@plycho](https://pioneer.joystreamstats.live/#/members/plycho) | active | 13 | 0.6 | 22.9 |
| 17 | [@dapplooker](https://pioneer.joystreamstats.live/#/members/dapplooker) | active | 13 | 0.6 | 22.1 |
| 18 | [@godshunter](https://pioneer.joystreamstats.live/#/members/godshunter) | active | 3 | 0.3 | 19.8 |
| 19 | [@bwhm0](https://pioneer.joystreamstats.live/#/members/bwhm0) | active | 0 | 0.0 | 0.0 |
| 21 | [@seainvestor](https://pioneer.joystreamstats.live/#/members/seainvestor) | active | 3 | 0.5 | 16.8 |
| 22 | [@0x2bc](https://pioneer.joystreamstats.live/#/members/0x2bc) | active | 43 | 1.8 | 37.1 |


### 4.4 Distribution
* [openings for distributionWorkingGroup](https://testnet.joystream.org/#/working-groups/opportunities/distribution)

| Property                | Start Block | End Block | % Change |
|-------------------------|--------------|--------------|----------|
| Number of Workers | 10 | 13 | 30 |
| Total  Stake | 7000000 | 10000000 | 42.86 |

| # | Member | Status | tJOY / Block | M tJOY Term | M tJOY total |
|--|--|--|--|--|--|
| 2 | [@maxlevush](https://pioneer.joystreamstats.live/#/members/maxlevush) | active | 23 | 2.7 | 5.2 |
| 3 | [@razumv](https://pioneer.joystreamstats.live/#/members/razumv) | active | 17 | 2.5 | 5.0 |
| 4 | [@art_khabibullin](https://pioneer.joystreamstats.live/#/members/art_khabibullin) | active | 3 | 2.1 | 4.0 |
| 5 | [@l1dev](https://pioneer.joystreamstats.live/#/members/l1dev) | active | 80 | 6.9 | 12.4 |
| 6 | [@ilich](https://pioneer.joystreamstats.live/#/members/ilich) | active | 5 | 2.2 | 3.9 |
| 7 | [@lkskrn](https://pioneer.joystreamstats.live/#/members/lkskrn) | active | 5 | 2.2 | 4.7 |
| 8 | [@oxygen](https://pioneer.joystreamstats.live/#/members/oxygen) | active | 5 | 2.2 | 3.9 |
| 9 | [@leet_joy](https://pioneer.joystreamstats.live/#/members/leet_joy) | active | 27 | 2.7 | 3.9 |
| 10 | [@igrex](https://pioneer.joystreamstats.live/#/members/igrex) | active | 21 | 2.2 | 3.6 |
| 11 | [@spat_sochi](https://pioneer.joystreamstats.live/#/members/spat_sochi) | active | 2 | 0.0 | 0.0 |
| 12 | [@0x2bc](https://pioneer.joystreamstats.live/#/members/0x2bc) | active | 2 | 0.0 | 0.0 |
| 13 | [@joystreamstats](https://pioneer.joystreamstats.live/#/members/joystreamstats) | active | 3 | 0.0 | 0.0 |


### 4.5 Operations
* [openings for operationsWorkingGroupAlpha](https://testnet.joystream.org/#/working-groups/opportunities/operationsGroupAlpha)

| Property                | Start Block | End Block | % Change |
|-------------------------|--------------|--------------|----------|
| Number of  Workers | 30 | 24 | -20 |
| Total  Stake | 1850000 | 1850000 | 0 |

| # | Member | Status | tJOY / Block | M tJOY Term | M tJOY total |
|--|--|--|--|--|--|
| 0 | [@l1dev](https://pioneer.joystreamstats.live/#/members/l1dev) | active | 40 | 4.0 | 77.2 |
| 15 | [@isonar](https://pioneer.joystreamstats.live/#/members/isonar) | active | 44 | 4.4 | 37.0 |
| 16 | [@lkskrn](https://pioneer.joystreamstats.live/#/members/lkskrn) | active | 56 | 5.6 | 68.4 |
| 17 | [@freakstatic](https://pioneer.joystreamstats.live/#/members/freakstatic) | active | 6 | 0.6 | 15.4 |
| 18 | [@dapplooker](https://pioneer.joystreamstats.live/#/members/dapplooker) | active | 28 | 1.7 | 17.3 |
| 20 | [@joystreamstats](https://pioneer.joystreamstats.live/#/members/joystreamstats) | active | 15 | 1.5 | 27.5 |
| 22 | [@arseniy2706](https://pioneer.joystreamstats.live/#/members/arseniy2706) | active | 3 | 0.3 | 6.1 |
| 24 | [@shtihmas](https://pioneer.joystreamstats.live/#/members/shtihmas) | active | 0 | 0.0 | 1.6 |
| 31 | [@ilich](https://pioneer.joystreamstats.live/#/members/ilich) | active | 3 | 0.3 | 2.9 |
| 32 | [@kate_fm](https://pioneer.joystreamstats.live/#/members/kate_fm) | active | 3 | 0.3 | 4.4 |
| 33 | [@ururu](https://pioneer.joystreamstats.live/#/members/ururu) | active | 3 | 0.3 | 8.9 |
| 34 | [@andybut](https://pioneer.joystreamstats.live/#/members/andybut) | active | 28 | 2.8 | 61.7 |
| 36 | [@chiffah](https://pioneer.joystreamstats.live/#/members/chiffah) | active | 4 | 0.4 | 5.6 |
| 39 | [@whitebarbie](https://pioneer.joystreamstats.live/#/members/whitebarbie) | active | 14 | 1.4 | 16.6 |
| 44 | [@oxygen](https://pioneer.joystreamstats.live/#/members/oxygen) | active | 3 | 0.3 | 4.9 |
| 45 | [@spat_sochi](https://pioneer.joystreamstats.live/#/members/spat_sochi) | active | 3 | 0.3 | 6.4 |
| 46 | [@svasilenko](https://pioneer.joystreamstats.live/#/members/svasilenko) | active | 4 | 0.4 | 2.4 |
| 48 | [@vlodkowjs](https://pioneer.joystreamstats.live/#/members/vlodkowjs) | active | 28 | 1.0 | 1.8 |
| 49 | [@darcksday](https://pioneer.joystreamstats.live/#/members/darcksday) | active | 28 | 1.0 | 1.8 |
| 50 | [@jen4ph](https://pioneer.joystreamstats.live/#/members/jen4ph) | active | 3 | 0.3 | 1.0 |
| 51 | [@igor171](https://pioneer.joystreamstats.live/#/members/igor171) | active | 3 | 0.3 | 1.0 |
| 55 | [@ars44](https://pioneer.joystreamstats.live/#/members/ars44) | active | 28 | 1.0 | 1.8 |
| 56 | [@oskarte](https://pioneer.joystreamstats.live/#/members/oskarte) | active | 3 | 0.3 | 1.0 |
| 57 | [@arsonque](https://pioneer.joystreamstats.live/#/members/arsonque) | active | 3 | 0.3 | 1.0 |


### 4.6 Marketing
* [openings for operationsWorkingGroupBeta](https://testnet.joystream.org/#/working-groups/opportunities/operationsGroupBeta)

| Property                | Start Block | End Block | % Change |
|-------------------------|--------------|--------------|----------|
| Number of  Workers | 1 | 7 | 600 |
| Total  Stake | 500000 | 500000 | 0 |

| # | Member | Status | tJOY / Block | M tJOY Term | M tJOY total |
|--|--|--|--|--|--|
| 0 | [@leet_joy](https://pioneer.joystreamstats.live/#/members/leet_joy) | active | 87 | 2.2 | 2.2 |
| 1 | [@igrex](https://pioneer.joystreamstats.live/#/members/igrex) | active | 4 | 0.1 | 0.1 |
| 2 | [@marat_mu](https://pioneer.joystreamstats.live/#/members/marat_mu) | active | 4 | 0.1 | 0.1 |
| 3 | [@kate_fm](https://pioneer.joystreamstats.live/#/members/kate_fm) | active | 4 | 0.1 | 0.1 |
| 4 | [@adovrn](https://pioneer.joystreamstats.live/#/members/adovrn) | active | 0 | 0.0 | 0.0 |
| 5 | [@kriptos](https://pioneer.joystreamstats.live/#/members/kriptos) | active | 0 | 0.0 | 0.0 |
| 6 | [@shtihmas](https://pioneer.joystreamstats.live/#/members/shtihmas) | active | 0 | 0.0 | 0.0 |


### 4.7 Gamma
* [openings for operationsWorkingGroupGamma](https://testnet.joystream.org/#/working-groups/opportunities/operationsGroupGamma)

| Property                | Start Block | End Block | % Change |
|-------------------------|--------------|--------------|----------|
| Number of  Workers | 0 | 1 | Infinity |
| Total  Stake | 0 | 500000 | Infinity |



## 5.0 User Generated Content
### 5.1 Membership Information
| Property          | Start Block | End Block | % Change |
|-------------------|--------------|--------------|----------|
| Number of members | 3367|  3383 | 0.48 |

### 5.2 Media & Uploads
| Property                | Start Block | End Block | % Change |
|-------------------------|--------------|--------------|----------|
| Number of uploads       | 14790 | 15082  |  1.97 |
| Size of content (MB)    |  2678319.03 |  3539443.44 | 32.15 |
| Number of channels      |  931 | 951 | 2.15 |

### 5.3 Forum Activity
| Property          | Start Block | End Block | % Change |
|-------------------|--------------|--------------|----------|
| Number of categories | 57 | 57 | 0 |
| Number of threads    | 945 | 951 | 0.63 |
| Number of posts      | 10756 | 11019 | 2.45 |
